/* ic-discover.c  - by sshlong (andrew cook)
 * brute force subdomain discovery;
 * 
 * You are free to use, modify, and redistribute this coe under 
 *  the terms of the GNU General Public License.
 * 
 * USAGE: ./discover whatever.edu <dictionary>  <number of children>
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>

int checkhost(char *hname)
{
    struct addrinfo poop, *res, *p;
    int status;
    char ipstr[INET6_ADDRSTRLEN];
 
    memset(&poop, 0, sizeof(poop));
    poop.ai_family = AF_UNSPEC;
    poop.ai_socktype = SOCK_STREAM;

    if ( (status = getaddrinfo(hname, NULL, &poop, &res)) == 0) {
	printf("%s\n", hname);
    }
}

void  nlparse(char *s, char *domain)
{
    int len = strlen(s);
    if (len > 0 && s[len-1] == '\n')
	s[len-1] = '\0';
    strcat(s, ".");
    strcat(s, domain);
}

int main(int argc, char **argv)
{
    if( argc != 4)
    {
	 printf("usage: ic-discover <host> <dict> <num children>\n");
	 exit(1);
    }
    
    int offspring = atoi(argv[3]);
    int spawns=0;
    int foo;
    char bhost[32];    
    FILE *names;
    names = fopen(argv[2], "r");
    if (names == NULL) {
	fprintf(stderr, "Can't open dictionary file\n");
	exit(1);
    }
    switch( fork() ) {
        case 0: {
            while ( fgets(bhost, sizeof(bhost), names) != NULL ) {
                nlparse(bhost,argv[1]);
                switch( fork() ) {
	            case 0: {
	                checkhost(bhost);
			fflush(stdout);
			exit(0);
	                break;
                    }
                    case -1: {
	                printf("error, something fork()'ed up\n");
	                exit(1);
	                break;
                    }
                    default: {
	                spawns++;
 	                if(spawns > offspring)  
			    wait(NULL); 
			break;
                    }
                }
            }   
        }

        break;

        case -1: {
            printf("Initial fork() got fork()'ed up, I know it's not very funny\n");
        }

        default: {
            printf("ic-discover by sshlong\n\n");
            wait(NULL);
            break;
        }   
        
    }
}
